#!/usr/bin/ruby

# Energy Balance Model

require 'tk'
require './ebm_param'


# make a figure file
n = 0
sFigFN = "/tmp/dcl"
loop do
  sFigFN = "/tmp/" + $0 + "-" + n.to_s
  break if !File.exist?(sFigFN+".pdf") && !File.exist?(sFigFN+".gif")
  n += 1
end


def imgwindow( imgfn )

  winimg = TkToplevel.new
  winimg.title = 'Figure'
  button = TkButton.new( winimg )
  button.text = 'close'
  button.command proc{winimg.destroy}
  button.pack('side' => 'top')
  imggif = TkPhotoImage.new
  imggif.file = imgfn
  label = TkLabel.new( winimg )
  label.text = 'Figure'
  label.image = imggif
  label.place('height'=>imggif.height,'width'=>imggif.width, 'x'=>10, 'y'=>10)
  label.pack('side' => 'top')

end


title = TkLabel.new
title.text = 'EBM'
title.pack( 'side'=>'top' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

heattransnum = TkVariable.new(1)

heattrans_name = TkLabel.new
heattrans_name.text = 'Heat transfer type'
heattrans_name.pack( 'side'=>'top' )

transcoef_frame = TkFrame.new.pack( 'side'=>'top' )
heattrans_button1 = TkRadioButton.new( transcoef_frame ) {
  text "Budyko-type"
  value 1
  variable heattransnum
#  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}
transcoef_name = TkLabel.new( transcoef_frame )
transcoef_name.text = 'heat transfer coefficient C (W m-2 K-1): '
transcoef_name.pack( 'side'=>'left' )
transcoef_value = TkEntry.new( transcoef_frame )
transcoef_value.value = TransferCoefC
transcoef_value.pack( 'side'=>'right' )

diffcoef_frame = TkFrame.new.pack( 'side'=>'top' )
heattrans_button2 = TkRadioButton.new( diffcoef_frame ) {
  text "Sellers-type"
  value 2
  variable heattransnum
#  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}
diffcoef_name = TkLabel.new( diffcoef_frame )
diffcoef_name.text = 'heat diffusion coefficient D (W m-2 K-1): '
diffcoef_name.pack( 'side'=>'left' )
diffcoef_value = TkEntry.new( diffcoef_frame )
diffcoef_value.value = DiffCoefD
diffcoef_value.pack( 'side'=>'right' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

alb_name = TkLabel.new
alb_name.text = 'Albedo'
alb_name.pack( 'side'=>'top' )
alb_frame = TkFrame.new.pack( 'side'=>'top' )
albf_name = TkLabel.new( alb_frame )
albf_name.text = 'Ice free:'
albf_name.pack( 'side'=>'left' )
albf_value = TkEntry.new( alb_frame )
albf_value.value = AlbedoIceFree
albf_value.pack( 'side'=>'left' )
albspace_name = TkLabel.new( alb_frame )
albspace_name.text = '   '
albspace_name.pack( 'side'=>'left' )
albi_name = TkLabel.new( alb_frame )
albi_name.text = 'Ice:'
albi_name.pack( 'side'=>'left' )
albi_value = TkEntry.new( alb_frame )
albi_value.value = AlbedoIce
albi_value.pack( 'side'=>'left' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

modenum = TkVariable.new(1)

mode_name = TkLabel.new
mode_name.text = 'Figure'
mode_name.pack( 'side'=>'top' )

mode_frame = TkFrame.new.pack( 'side'=>'top' )
mode_button1 = TkRadioButton.new( mode_frame ) {
  text "Ice line latitude"
  value 1
  variable modenum
#  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}
mode_button2 = TkRadioButton.new( mode_frame ) {
  text "Global mean temperature"
  value 2
  variable modenum
#  command proc{ label.bg(mode.value) }
  pack( 'anchor'=>'w', 'side'=>'left' )
}

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

solcon_name = TkLabel.new
solcon_name.text = 'Solar constant (W m-2): '
solcon_name.pack( 'side'=>'top' )
solcon_frame = TkFrame.new.pack( 'side'=>'top' )
solcon1_name = TkLabel.new( solcon_frame )
solcon1_name.text = 'Min.:'
solcon1_name.pack( 'side'=>'left' )
solcon1_value = TkEntry.new( solcon_frame )
solcon1_value.value = 1100.0
solcon1_value.pack( 'side'=>'left' )
solcon2_name = TkLabel.new( solcon_frame )
solcon2_name.text = 'Max.:'
solcon2_name.pack( 'side'=>'left' )
solcon2_value = TkEntry.new( solcon_frame )
solcon2_value.value = 1900.0
solcon2_value.pack( 'side'=>'left' )

TkLabel.new{
  text '==================================================================================='
}.pack( 'side'=>'top' )

file_name = TkLabel.new
file_name.text = 'Temporary figure file (*.pdf, *.gif)'
file_name.pack( 'side'=>'top' )
file_frame = TkFrame.new.pack( 'side'=>'top' )
file_name = TkLabel.new( file_frame )
file_name.text = 'path:'
file_name.pack( 'side'=>'left' )
file_value = TkEntry.new( file_frame )
file_value.value = sFigFN
file_value.pack( 'side'=>'left' )
file_remove_var = TkVariable.new
file_remove_var.value = 1
file_button = TkCheckButton.new( file_frame ) {
  text "Remove figure file"
  onvalue = 1
  offvalue = 0
  variable file_remove_var
  pack( 'anchor'=>'w', 'side'=>'left' )
}

button_exec = TkButton.new
button_exec.text = 'execute'
button_exec.command{
  $modenum          = modenum.value.to_f
  $heattransfertype = heattransnum.value.to_f
  $solcon1          = solcon1_value.value.to_f
  $solcon2          = solcon2_value.value.to_f
  $albi             = albi_value.value.to_f
  $albf             = albf_value.value.to_f
  $transcoef        = transcoef_value.value.to_f
  $diffcoef         = diffcoef_value.value.to_f
  sFigFN            = file_value.value
#  print $latice, "\n"
  com = "ruby ebm_ctl.rb "+sFigFN+" "+$modenum.to_s+" "+$heattransfertype.to_s+" "+($solcon1 / 4).to_s+" "+($solcon2 / 4).to_s+" "+$albf.to_s+" "+$albi.to_s+" "+$transcoef.to_s+" "+$diffcoef.to_s
  system( com )
  system( "convert -rotate 90 -background white -flatten "+sFigFN+".pdf "+sFigFN+".gif" )
  imgwindow( sFigFN+'.gif' )
  if file_remove_var.value.to_i == 1 then
    system( "rm "+sFigFN+".pdf" ) if File.exist?(sFigFN+".pdf")
    system( "rm "+sFigFN+".gif" ) if File.exist?(sFigFN+".gif")
  end
}
button_exec.pack( 'side' => 'left' )

#button_exec.bind( 'Button', proc {ebm_draw_temp} )
#button_exec.bind( 'Button', proc { showtext } )
#ebm_draw_temp if ARGV.size == 0

button_exit = TkButton.new
button_exit.text = 'exit'
button_exit.command = proc{ exit }
button_exit.pack( 'side' => 'right' )

Tk.mainloop
