#!/usr/bin/ruby

# Stefan-Boltzmann constant
SBConst = 5.67e-8

# zero degree celsius
Temp0          = 273.0
# freezing temperature ( temperature for albedo change )
TempIce       = Temp0 - 10.0

# Lindzen
# coefficients for planetary radiation (PlanetRadCoefA + PlanetRadCoefB * T)
PlanetRadCoefB = 1.55
PlanetRadCoefA = 211.1 - Temp0 * PlanetRadCoefB
# coefficient for heat transfer ( - TransferCoefC * ( T - \bar{T} ) )
TransferCoefC  = 2.45 * PlanetRadCoefB
# coefficient for heat diffusion
#DiffCoefD      = 0.0
DiffCoefD      = 0.1
# albedo for ice free and ice covered surface
AlbedoIce     = 0.6
AlbedoIceFree = 0.3


#  # McGuffie and Henderson-Sellers
#  # coefficients for planetary radiation (PlanetRadCoefA + PlanetRadCoefB * T)
#  PlanetRadCoefB = 2.17
#  PlanetRadCoefA = 204.0 - Temp0 * PlanetRadCoefB
#  # coefficient for heat transfer ( - TransferCoefC * ( T - \bar{T} ) )
#  TransferCoefC  = 3.81
#  #TransferCoefC  = 0.0
#  # albedo for ice free and ice covered surface
#  AlbedoIce     = 0.62
#  AlbedoIceFree = 0.35
